# Generates a manifest with a class containing N apache::vhost resources.
# The user is prompted for the namespace, class name, and number of vhost
# resources to put in the class.
#
# This is used for quickly building a manifest that will result in a large
# catalog during an agent run.
 
print "Enter namespace: "
namespace = gets.chomp

print "Enter class: "
classname = gets.chomp

print "Enter number of apache::vhosts to declare: "
number_of_vhosts = gets.chomp.to_i

qname = namespace + "::" + classname
manifest = "#{ENV['PWD']}/manifests/#{classname}.pp"

puts "Generating #{qname}..."

def add_vhost(file, hostnumber)
  file.puts "\n"
  file.puts "  apache::vhost { 'www.dummyhost#{hostnumber}.com':" 
  file.puts "    port    => '80',"
  file.puts "    docroot => '/var/www/dummyhost#{hostnumber}',"
  file.puts "  }"
end

File.open(manifest, 'w') { |file|
  file.puts "class #{qname} {"
  file.puts "  include apache"

  number_of_vhosts.times { |i| add_vhost(file, i+1) }

  file.puts "}"
}

puts "Manifest generated at #{manifest}"
